layui.define(['jquery', 'form', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var form = layui.form;
    var utils = layui.formUtils;
    var formField = layui.formField;

    var HTML_ARRAY = [
        '<div id="{0}Box" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">',
        '   <label class="layui-form-label" style="width: {1}px;">{0}:</label>',
        '   <div id="{1}Block" class="layui-input-block" style="margin-left: {0}px">',
        '       <input type="radio" name="{0}" value="{1}" title="{2}" checked="" {3}>',
        '       <input type="radio" name="{0}" value="{1}" title="{2}" {3}>',
        '   </div>',
        '</div>'
    ];

    var radio = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _html = HTML_ARRAY[0].format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += HTML_ARRAY[1].format(json.label, json.labelWidth);
            _html += HTML_ARRAY[2].format(json.labelWidth, json.id);
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += HTML_ARRAY[3].format(json.id, json.options[i].value, json.options[i].text, _disabled);
                } else {
                    _html += HTML_ARRAY[4].format(json.id, json.options[i].value, json.options[i].text, _disabled);
                }
            }
            _html += HTML_ARRAY[5];
            _html += HTML_ARRAY[6];
            return _html;
        },
        update: function (json) {
            var _disabled = json.disabled ? 'disabled=""' : '';
            var $block = $('#' + json.id + 'Box .layui-input-block');
            var $label = $('#' + json.id + 'Box .layui-form-label');
            $block.empty();
            $label.empty();
            $block.css("margin-left", json.labelWidth);
            $label.css("width", json.labelWidth);
            $label.append(json.label + ":");
            $block.css({
                width: 'calc({0} - {1}px)'.format(json.width, json.labelWidth)
            });
            var _html = '';
            //重绘设计区改id下的所有元素
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += HTML_ARRAY[3].format(json.id, json.options[i].value, json.options[i].text, _disabled);
                } else {
                    _html += HTML_ARRAY[4].format(json.id, json.options[i].value, json.options[i].text, _disabled);
                }
            }
            $block.append(_html);
            form.render('radio');
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.radio));
            _json.id = id == undefined ? guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        }
    };

    exports('radio', radio);
});